var filter;
var one_time_filter;
jQuery( document ).ready( function() {
    //variable for set/unset loading
    var loading = false;

    jQuery( '.nav_button' ).click( function() {
        if( loading ) {
            return false;
        }
        var obj = jQuery(this);

        //add select class to this element
        jQuery( '.nav_button' ).removeClass( 'selected' );
        jQuery(this).addClass( 'selected' );

        //hide new message form
        jQuery( '.add_new_message' ).hide();
        jQuery( '.wpc_msg_chain_content' ).hide();

        //temp wrapper html
        var html = jQuery('.wpc_msg_content_wrapper_inner').html();
        jQuery('.wpc_msg_content_wrapper_inner').html('');

        //reset bulk check
        jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', false );
        jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', false);

        jQuery('.wpc_msg_pagination').data('pagenumber', 1);

        var filters = '';
        if( typeof one_time_filter !== 'undefined' && Object.keys(one_time_filter).length > 0 ) {
            filters = jQuery.base64Encode( JSON.stringify( one_time_filter ) );
        }

        //show loader
        jQuery( '.wpc_ajax_overflow' ).show();
        loading = true;
        jQuery.ajax({
            type: 'POST',
            url: ajax_url,
            data: 'action=wpc_message_get_list&type=' + jQuery(this).data('list') + '&filters=' + filters,
            dataType: "json",
            success: function( data ) {
                if( !data.status ) {
                    jQuery('.wpc_msg_content_wrapper_inner').html( html );
                    jQuery( '.wpc_ajax_overflow' ).hide();
                    alert( data.message );
                } else {
                    jQuery('.wpc_msg_content_wrapper_inner').html( data.html ).show();

                    resize_messages_content();

                    if( obj.data('list') == 'trash' ) {
                        jQuery( '.wpc_msg_bulk_actions_wrapper .bulk_actions li[data-action="delete"]').hide();
                        jQuery( '.wpc_msg_bulk_actions_wrapper .bulk_actions li[data-action="restore"]').show();
                        jQuery( '.wpc_msg_bulk_actions_wrapper .bulk_actions li[data-action="delete_permanently"]').show();
                    } else {
                        jQuery( '.wpc_msg_bulk_actions_wrapper .bulk_actions li[data-action="delete"]').show();
                        jQuery( '.wpc_msg_bulk_actions_wrapper .bulk_actions li[data-action="restore"]').hide();
                        jQuery( '.wpc_msg_bulk_actions_wrapper .bulk_actions li[data-action="delete_permanently"]').hide();
                    }

                    if( data.is_empty ) {
                        //hide navigation
                        jQuery( '.wpc_msg_top_nav_wrapper' ).hide();
                        jQuery( '.wpc_msg_pagination' ).hide();
                        jQuery( '.wpc_msg_bulk_all' ).hide();
                    } else {
                        //show navigation
                        jQuery( '.wpc_msg_top_nav_wrapper' ).show();
                        jQuery( '.wpc_msg_pagination' ).show();
                        jQuery( '.wpc_msg_bulk_all' ).show();
                    }

                    if( data.pagination !== false ) {
                        jQuery( '.wpc_msg_pagination_text .total_count' ).html( data.pagination.count );
                        jQuery( '.wpc_msg_pagination_text .start_count' ).html( data.pagination.start );
                        jQuery( '.wpc_msg_pagination_text .end_count' ).html( data.pagination.end );

                        if( data.pagination.current_page > 1 ) {
                            jQuery( '.wpc_msg_next_button' ).removeClass( 'disabled' );
                        } else {
                            jQuery( '.wpc_msg_next_button' ).addClass( 'disabled' );
                        }

                        if( data.pagination.pages_count == data.pagination.current_page ) {
                            jQuery( '.wpc_msg_prev_button' ).addClass( 'disabled' );
                        } else {
                            jQuery( '.wpc_msg_prev_button' ).removeClass( 'disabled' );
                        }
                    }

                    jQuery( '.wpc_msg_filter_by' ).trigger( 'change' );

                    if( typeof one_time_filter !== 'undefined' && Object.keys(one_time_filter).length > 0 ) {
                        filter = one_time_filter;
                        one_time_filter = {};
                    } else {
                        jQuery( '.wpc_msg_active_filters_wrapper').html('');
                        jQuery( '.wpc_msg_search').val('');
                        jQuery( '.wpc_ajax_overflow' ).hide();
                        filter = {};
                    }
                }
                loading = false;
            }
        });
    });

    jQuery( document ).on( 'click', '.wpc_msg_prev_button', function() {
        if( jQuery(this).hasClass('disabled') ) {
            return false;
        }

        if( loading ) {
            return false;
        }

        var obj = jQuery(this);

        var filters = '';
        if( typeof filter !== 'undefined' && Object.keys(filter).length > 0 ) {
            filters = jQuery.base64Encode( JSON.stringify( filter ) );
        }

        //reset bulk check
        jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', false );
        jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', false);

        //show loader
        jQuery( '.wpc_ajax_overflow' ).show();
        loading = true;
        jQuery.ajax({
            type: 'POST',
            url: ajax_url,
            data: 'action=wpc_message_get_list&type=' + jQuery('.nav_button.selected').data('list') + '&page=' + ( jQuery(this).parents('.wpc_msg_pagination').data('pagenumber')*1 + 1 ) + '&search=' + jQuery('.wpc_msg_search').val() + '&filters=' + filters,
            dataType: "json",
            success: function( data ) {
                if( !data.status ) {
                    jQuery( '.wpc_ajax_overflow' ).hide();
                    alert( data.message );
                } else {
                    jQuery('.wpc_msg_content_wrapper_inner').html( data.html );

                    resize_messages_content();

                    obj.parents('.wpc_msg_pagination').data('pagenumber', obj.parents('.wpc_msg_pagination').data('pagenumber')*1 + 1 );

                    if( data.pagination !== false ) {
                        jQuery( '.wpc_msg_pagination_text .total_count' ).html( data.pagination.count );
                        jQuery( '.wpc_msg_pagination_text .start_count' ).html( data.pagination.start );
                        jQuery( '.wpc_msg_pagination_text .end_count' ).html( data.pagination.end );

                        if( data.pagination.current_page > 1 ) {
                            jQuery( '.wpc_msg_next_button' ).removeClass( 'disabled' );
                        } else {
                            jQuery( '.wpc_msg_next_button' ).addClass( 'disabled' );
                        }

                        if( data.pagination.pages_count == data.pagination.current_page ) {
                            jQuery( '.wpc_msg_prev_button' ).addClass( 'disabled' );
                        } else {
                            jQuery( '.wpc_msg_prev_button' ).removeClass( 'disabled' );
                        }
                    }

                    jQuery( '.wpc_ajax_overflow' ).hide();
                }
                loading = false;
            }
        });
    });

    jQuery( document ).on( 'click', '.wpc_msg_next_button', function() {
        if( jQuery(this).hasClass('disabled') ) {
            return false;
        }

        if( loading ) {
            return false;
        }

        var obj = jQuery(this);

        var filters = '';
        if( typeof filter !== 'undefined' && Object.keys(filter).length > 0 ) {
            filters = jQuery.base64Encode( JSON.stringify( filter ) );
        }

        //reset bulk check
        jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', false );
        jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', false);

        //show loader
        jQuery( '.wpc_ajax_overflow' ).show();
        loading = true;
        jQuery.ajax({
            type: 'POST',
            url: ajax_url,
            data: 'action=wpc_message_get_list&type=' + jQuery('.nav_button.selected').data('list') + '&page=' + ( jQuery(this).parents('.wpc_msg_pagination').data('pagenumber')*1 - 1 ) + '&search=' + jQuery('.wpc_msg_search').val() + '&filters=' + filters,
            dataType: "json",
            success: function( data ) {
                if( !data.status ) {
                    jQuery( '.wpc_ajax_overflow' ).hide();
                    alert( data.message );
                } else {
                    jQuery('.wpc_msg_content_wrapper_inner').html( data.html );

                    resize_messages_content();

                    obj.parents('.wpc_msg_pagination').data('pagenumber', obj.parents('.wpc_msg_pagination').data('pagenumber')*1 - 1 );

                    if( data.pagination !== false ) {
                        jQuery( '.wpc_msg_pagination_text .total_count' ).html( data.pagination.count );
                        jQuery( '.wpc_msg_pagination_text .start_count' ).html( data.pagination.start );
                        jQuery( '.wpc_msg_pagination_text .end_count' ).html( data.pagination.end );

                        if( data.pagination.current_page > 1 ) {
                            jQuery( '.wpc_msg_next_button' ).removeClass( 'disabled' );
                        } else {
                            jQuery( '.wpc_msg_next_button' ).addClass( 'disabled' );
                        }

                        if( data.pagination.pages_count == data.pagination.current_page ) {
                            jQuery( '.wpc_msg_prev_button' ).addClass( 'disabled' );
                        } else {
                            jQuery( '.wpc_msg_prev_button' ).removeClass( 'disabled' );
                        }
                    }

                    jQuery( '.wpc_ajax_overflow' ).hide();
                }
                loading = false;
            }
        });
    });


    jQuery( document ).on( 'click', '.wpc_msg_refresh_button', function() {
        if( jQuery(this).hasClass('disabled') ) {
            return false;
        }

        if( loading ) {
            return false;
        }

        var obj = jQuery(this);

        if( obj.data('object') == 'chains' ) {
            var filters = '';
            if( typeof filter !== 'undefined' && Object.keys(filter).length > 0 ) {
                filters = jQuery.base64Encode( JSON.stringify( filter ) );
            }

            //reset bulk check
            jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', false );
            jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', false);

            //show loader
            jQuery( '.wpc_ajax_overflow' ).show();
            loading = true;
            jQuery.ajax({
                type: 'POST',
                url: ajax_url,
                data: 'action=wpc_message_get_list&type=' + jQuery('.nav_button.selected').data('list') + '&page=' + ( jQuery(this).parents('.wpc_msg_pagination').data('pagenumber')*1 ) + '&search=' + jQuery('.wpc_msg_search').val() + '&filters=' + filters,
                dataType: "json",
                success: function( data ) {
                    if( !data.status ) {
                        jQuery( '.wpc_ajax_overflow' ).hide();
                        alert( data.message );
                    } else {
                        jQuery('.wpc_msg_content_wrapper_inner').html( data.html );

                        resize_messages_content();

                        if( data.is_empty ) {
                            //hide navigation
                            jQuery( '.wpc_msg_top_nav_wrapper' ).hide();
                            jQuery( '.wpc_msg_pagination' ).hide();
                            jQuery( '.wpc_msg_bulk_all' ).hide();
                        } else {
                            //show navigation
                            jQuery( '.wpc_msg_top_nav_wrapper' ).show();
                            jQuery( '.wpc_msg_pagination' ).show();
                            jQuery( '.wpc_msg_bulk_all' ).show();
                        }

                        if( data.pagination !== false ) {
                            jQuery( '.wpc_msg_pagination_text .total_count' ).html( data.pagination.count );
                            jQuery( '.wpc_msg_pagination_text .start_count' ).html( data.pagination.start );
                            jQuery( '.wpc_msg_pagination_text .end_count' ).html( data.pagination.end );

                            if( data.pagination.current_page > 1 ) {
                                jQuery( '.wpc_msg_next_button' ).removeClass( 'disabled' );
                            } else {
                                jQuery( '.wpc_msg_next_button' ).addClass( 'disabled' );
                            }

                            if( data.pagination.pages_count == data.pagination.current_page ) {
                                jQuery( '.wpc_msg_prev_button' ).addClass( 'disabled' );
                            } else {
                                jQuery( '.wpc_msg_prev_button' ).removeClass( 'disabled' );
                            }
                        }

                        jQuery( '.wpc_ajax_overflow' ).hide();
                    }
                    loading = false;
                }
            });
        } else if( obj.data('object') == 'chain' ) {
            //show loader
            jQuery( '.wpc_ajax_overflow' ).show();
            loading = true;
            jQuery.ajax({
                type: 'POST',
                url: ajax_url,
                data: 'action=wpc_message_get_chain&chain_id=' + obj.data('chain_id'),
                dataType: "json",
                success: function( data ) {
                    if( !data.status ) {
                        jQuery( '.wpc_ajax_overflow' ).hide();
                        alert( data.message );
                    } else {
                        jQuery( '.wpc_msg_chain_content' ).html( data.html );
                        jQuery( '.wpc_ajax_overflow' ).hide();
                    }
                    loading = false;
                }
            });
        }

    });


    jQuery( '.wpc_msg_search_button' ).click( function() {
        var obj = jQuery( this );

        var was_opened = obj.hasClass( 'opened' );
        if( !was_opened ) {
            obj.toggleClass( 'opened' );
        }

        obj.siblings( '.wpc_msg_search' ).animate({
            width: "toggle"
        }, 1000, function() {
            if( was_opened ) {
                obj.toggleClass( 'opened' );
            }
        });
    });

    jQuery( document ).on( 'change', '.wpc_msg_search', function() {
        if( loading ) {
            return false;
        }

        var filters = '';
        if( typeof filter !== 'undefined' && Object.keys(filter).length > 0 ) {
            filters = jQuery.base64Encode( JSON.stringify( filter ) );
        }

        //reset bulk check
        jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', false );
        jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', false);

        //show loader
        jQuery( '.wpc_ajax_overflow' ).show();
        loading = true;
        jQuery.ajax({
            type: 'POST',
            url: ajax_url,
            data: 'action=wpc_message_get_list&type=' + jQuery('.nav_button.selected').data('list') + '&search=' + jQuery(this).val() + '&filters=' + filters,
            dataType: "json",
            success: function( data ) {
                if( !data.status ) {
                    jQuery( '.wpc_ajax_overflow' ).hide();
                    alert( data.message );
                } else {
                    jQuery('.wpc_msg_content_wrapper_inner').html( data.html );

                    resize_messages_content();

                    jQuery('.wpc_msg_pagination').data('pagenumber', 1);

                    if( data.is_empty ) {
                        //hide navigation
                        jQuery( '.wpc_msg_pagination' ).hide();
                        jQuery( '.wpc_msg_bulk_all' ).hide();

                        if( !( typeof filter !== 'undefined' && Object.keys(filter).length > 0 ) ) {
                            jQuery( '.wpc_msg_filter' ).hide();
                        }
                    } else {
                        //show navigation
                        jQuery( '.wpc_msg_pagination' ).show();
                        jQuery( '.wpc_msg_bulk_all' ).show();
                        jQuery( '.wpc_msg_filter' ).show();
                    }

                    if( data.pagination !== false ) {
                        jQuery( '.wpc_msg_pagination_text .total_count' ).html( data.pagination.count );
                        jQuery( '.wpc_msg_pagination_text .start_count' ).html( data.pagination.start );
                        jQuery( '.wpc_msg_pagination_text .end_count' ).html( data.pagination.end );

                        if( data.pagination.current_page > 1 ) {
                            jQuery( '.wpc_msg_next_button' ).removeClass( 'disabled' );
                        } else {
                            jQuery( '.wpc_msg_next_button' ).addClass( 'disabled' );
                        }

                        if( data.pagination.pages_count == data.pagination.current_page ) {
                            jQuery( '.wpc_msg_prev_button' ).addClass( 'disabled' );
                        } else {
                            jQuery( '.wpc_msg_prev_button' ).removeClass( 'disabled' );
                        }
                    }

                    jQuery( '.wpc_msg_filter_by' ).trigger( 'change' );

                    jQuery( '.wpc_ajax_overflow' ).hide();
                }
                loading = false;
            }
        });
    });


    jQuery( '.wpc_msg_content_wrapper' ).on( 'click', '.wpc_msg_item', function(e) {
        var checkedCount = jQuery( '.wpc_msg_item:checked' ).length;
        var checksCount = jQuery( '.wpc_msg_item' ).length;

        if( checkedCount == 0 ) {
            jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', false );
            jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', false);
        } else if( checkedCount == checksCount ) {
            jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', true );
            jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', false);
        } else if( checkedCount > 0 && checkedCount < checksCount ) {
            jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', false );
            jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', true);
        }

        e.stopPropagation();
    });

    jQuery( '.wpc_msg_content_wrapper' ).on( 'click', '.wpc_msg_bulk_check', function(e) {
        if( jQuery(this).is(':checked') ) {
            jQuery( '.wpc_msg_item' ).prop( 'checked', true );
        } else {
            jQuery( '.wpc_msg_item' ).prop( 'checked', false );
        }
        e.stopPropagation();
    });

    jQuery( '.wpc_msg_content_wrapper' ).on( 'click', '.wpc_msg_bulk_all', function(e) {
        jQuery(this).toggleClass( 'bulk_opened' );

        e.stopPropagation();

        jQuery( 'body' ).bind( 'click', function( event ) {
            jQuery( '.wpc_msg_bulk_all' ).removeClass( 'bulk_opened' );
            jQuery( 'body' ).unbind( event );
        });
    });

    jQuery( '.wpc_msg_content_wrapper' ).on( 'click', '.wpc_msg_bulk_actions_wrapper', function(e){
        e.preventDefault();
        e.stopPropagation();
    });


    jQuery( '.wpc_msg_content_wrapper' ).on( 'click', '.bulk_select li', function() {
        var select = jQuery(this).data( 'select' );

        if( select == 'all' ) {
            if( jQuery('.wpc_msg_bulk_check').is(':checked') ) {
                return false;
            } else {
                jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', true ).prop( 'indeterminate', false);
                jQuery( '.wpc_msg_item' ).prop( 'checked', true );
            }
        } else if( select == 'none' ) {
            jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', false ).prop( 'indeterminate', false);
            jQuery( '.wpc_msg_item' ).prop( 'checked', false );
        } else if( select == 'unread' ) {
            jQuery( '.wpc_msg_item[data-new="true"]' ).prop( 'checked', true );
            jQuery( '.wpc_msg_item[data-new="false"]' ).prop( 'checked', false );

            var checkedCount = jQuery( '.wpc_msg_item:checked' ).length;
            var checksCount = jQuery( '.wpc_msg_item' ).length;

            if( checkedCount == 0 ) {
                jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', false );
                jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', false);
            } else if( checkedCount == checksCount ) {
                jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', true );
                jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', false);
            } else if( checkedCount > 0 && checkedCount < checksCount ) {
                jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', false );
                jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', true);
            }
        } else if( select == 'read' ) {
            jQuery( '.wpc_msg_item[data-new="true"]' ).prop( 'checked', false );
            jQuery( '.wpc_msg_item[data-new="false"]' ).prop( 'checked', true );

            var checkedCount = jQuery( '.wpc_msg_item:checked' ).length;
            var checksCount = jQuery( '.wpc_msg_item' ).length;

            if( checkedCount == 0 ) {
                jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', false );
                jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', false);
            } else if( checkedCount == checksCount ) {
                jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', true );
                jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', false);
            } else if( checkedCount > 0 && checkedCount < checksCount ) {
                jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', false );
                jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', true);
            }
        }

        jQuery('.wpc_msg_bulk_all').removeClass( 'bulk_opened' );
    });


    jQuery( '.wpc_msg_content_wrapper' ).on( 'click', '.bulk_actions li', function() {
        var action = jQuery(this).data( 'action' );

        if( jQuery( '.wpc_msg_item:checked' ).length <= 0 ) {
            return false;
        }

        var chain_ids = [];
        jQuery( '.wpc_msg_item:checked' ).each( function() {
            chain_ids.push( jQuery(this).val() );
        });

        if( action == 'read' ) {
            jQuery.ajax({
                type: 'POST',
                url: ajax_url,
                data: 'action=wpc_message_chain_mark_read&chain_ids=' + jQuery.base64Encode( JSON.stringify( chain_ids ) ),
                dataType: "json",
                success: function( data ){
                    if( !data.status ) {
                        alert( data.message );
                    } else {
                        jQuery( '.wpc_msg_item:checked' ).each( function() {
                            jQuery(this).parents( 'tr' ).find( '.wpc_messages_count, .wpc_chain_members, .wpc_chain_subject, .column-date span' ).css( 'font-weight', 'normal' );
                        });
                    }
                }
            });
        } else if( action == 'delete' ) {
            jQuery.ajax({
                type: 'POST',
                url: ajax_url,
                data: 'action=wpc_message_chain_to_trash&chain_ids=' + jQuery.base64Encode( JSON.stringify( chain_ids ) ),
                dataType: "json",
                success: function( data ){
                    if( !data.status ) {
                        alert( data.message );
                    } else {
                        jQuery('.wpc_msg_refresh_button[data-object="chains"]').trigger('click');
                    }
                }
            });
        } else if( action == 'delete_permanently' ) {
            jQuery.ajax({
                type: 'POST',
                url: ajax_url,
                data: 'action=wpc_message_chain_delete_permanently&chain_ids=' + jQuery.base64Encode( JSON.stringify( chain_ids ) ),
                dataType: "json",
                success: function( data ){
                    if( !data.status ) {
                        alert( data.message );
                    } else {
                        jQuery('.wpc_msg_refresh_button[data-object="chains"]').trigger('click');
                    }
                }
            });
        } else if( action == 'restore' ) {
            jQuery.ajax({
                type: 'POST',
                url: ajax_url,
                data: 'action=wpc_message_chain_restore&chain_ids=' + jQuery.base64Encode( JSON.stringify( chain_ids ) ),
                dataType: "json",
                success: function( data ){
                    if( !data.status ) {
                        alert( data.message );
                    } else {
                        jQuery('.wpc_msg_refresh_button[data-object="chains"]').trigger('click');
                    }
                }
            });
        }

        jQuery('.wpc_msg_bulk_all').removeClass( 'bulk_opened' );
    });


    jQuery( '.wpc_msg_content_wrapper' ).on( 'click', '.wpc_msg_filter', function(e) {
        jQuery(this).toggleClass( 'filter_opened' );

        e.stopPropagation();

        jQuery( 'body' ).bind( 'click', function( event ) {
            jQuery( '.wpc_msg_filter' ).removeClass( 'filter_opened' );
            jQuery( 'body' ).unbind( event );
        });
    });

    jQuery( '.wpc_msg_content_wrapper' ).on( 'click', '.wpc_msg_filter_wrapper', function(e){
        e.preventDefault();
        e.stopPropagation();
    });

    jQuery( '.wpc_msg_content_wrapper' ).on( 'change', '.wpc_msg_filter_by', function() {
        var obj = jQuery(this);

        obj.parents('.wpc_msg_filter_wrapper').find( '.wpc_ajax_content' ).addClass( 'wpc_is_loading' );
        jQuery.ajax({
            type: 'POST',
            url: ajax_url,
            data: 'action=wpc_message_get_filter&type=' + jQuery('.nav_button.selected').data('list') + '&search=' + jQuery('.wpc_msg_search').val() + '&by=' + jQuery(this).val(),
            dataType: "json",
            success: function( data ){
                if( !data.status ) {
                    alert( data.message );
                } else {
                    obj.parents('.wpc_msg_filter_wrapper').find( '.wpc_msg_filter_selectors' ).html( data.filter_html );

                    if( obj.val() == 'member' ) {
                        jQuery( '.wpc_msg_filter_members' ).wpc_select({
                            search:true,
                            opacity:'0.2'
                        });
                    } else if( obj.val() == 'date' ) {
                        if( typeof( custom_datepicker_init ) !== 'undefined' ) {
                            custom_datepicker_init();
                        }

                        jQuery('.from_date_field').datepicker( "option", {
                            minDate: new Date( data.mindate*1000 ),
                            maxDate: new Date( data.maxdate*1000 ),
                            onClose: function( selectedDate ) {
                                jQuery('.to_date_field').datepicker( "option", "minDate", selectedDate );
                            }
                        });

                        jQuery('.to_date_field').datepicker( "option", {
                            minDate: new Date( data.mindate*1000 ),
                            maxDate: new Date( data.maxdate*1000 ),
                            onClose: function( selectedDate ) {
                                jQuery('.from_date_field').datepicker( "option", "maxDate", selectedDate );
                            }
                        });
                    }

                    obj.parents('.wpc_msg_filter_wrapper').find( '.wpc_ajax_content' ).removeClass( 'wpc_is_loading' );
                }
            }
        });
    });


    //change filtering reload
    jQuery( '.wpc_msg_content_wrapper' ).on( 'change', '.wpc_msg_active_filters_wrapper', function() {
        if( loading ) {
            return false;
        }

        var filters = '';
        if( typeof filter !== 'undefined' && Object.keys(filter).length > 0 ) {
            filters = jQuery.base64Encode( JSON.stringify( filter ) );
        }

        //reset bulk check
        jQuery( '.wpc_msg_bulk_check' ).prop( 'checked', false );
        jQuery( '.wpc_msg_bulk_check' ).prop( 'indeterminate', false);

        //show loader
        jQuery( '.wpc_ajax_overflow' ).show();
        loading = true;
        jQuery.ajax({
            type: 'POST',
            url: ajax_url,
            data: 'action=wpc_message_get_list&type=' + jQuery('.nav_button.selected').data('list') + '&search=' + jQuery('.wpc_msg_search').val() + '&filters=' + filters,
            dataType: "json",
            success: function( data ) {
                if( !data.status ) {
                    jQuery( '.wpc_ajax_overflow' ).hide();
                    alert( data.message );
                } else {
                    jQuery('.wpc_msg_content_wrapper_inner').html( data.html );

                    resize_messages_content();

                    jQuery('.wpc_msg_pagination').data('pagenumber', 1);

                    if( data.is_empty ) {
                        //hide navigation
                        jQuery( '.wpc_msg_pagination' ).hide();
                        jQuery( '.wpc_msg_bulk_all' ).hide();
                        jQuery( '.wpc_msg_filter' ).hide();

                        if( jQuery('.wpc_msg_search').val() == '' ) {
                            jQuery( '.wpc_msg_search_line' ).hide();
                        }
                    } else {
                        //show navigation
                        jQuery( '.wpc_msg_pagination' ).show();
                        jQuery( '.wpc_msg_bulk_all' ).show();
                        jQuery( '.wpc_msg_search_line' ).show();
                        jQuery( '.wpc_msg_filter' ).show();
                    }

                    if( data.pagination !== false ) {
                        jQuery( '.wpc_msg_pagination_text .total_count' ).html( data.pagination.count );
                        jQuery( '.wpc_msg_pagination_text .start_count' ).html( data.pagination.start );
                        jQuery( '.wpc_msg_pagination_text .end_count' ).html( data.pagination.end );

                        if( data.pagination.current_page > 1 ) {
                            jQuery( '.wpc_msg_next_button' ).removeClass( 'disabled' );
                        } else {
                            jQuery( '.wpc_msg_next_button' ).addClass( 'disabled' );
                        }

                        if( data.pagination.pages_count == data.pagination.current_page ) {
                            jQuery( '.wpc_msg_prev_button' ).addClass( 'disabled' );
                        } else {
                            jQuery( '.wpc_msg_prev_button' ).removeClass( 'disabled' );
                        }
                    }

                    jQuery( '.wpc_msg_filter_by' ).trigger( 'change' );

                    jQuery( '.wpc_ajax_overflow' ).hide();
                }
                loading = false;
            }
        });
    });


    //add filter
    jQuery( '.wpc_msg_content_wrapper' ).on( 'click', '.wpc_msg_add_filter', function() {
        var obj = jQuery(this);

        var filter_before = filter;
        var filter_by = obj.parents( '.wpc_msg_filter' ).find('.wpc_msg_filter_by').val();

        if( typeof filter_before === 'undefined' ) {
            filter = {};
            filter[filter_by] = [];
        }

        if( !filter.hasOwnProperty( filter_by ) ) {
            filter[filter_by] = [];
        }

        if( filter_by == 'member' ) {
            var member_id = obj.parents( '.wpc_msg_filter' ).find('.wpc_msg_filter_members').val();

            var in_array = false;

            if( typeof filter_before !== 'undefined' && filter_before.hasOwnProperty( filter_by ) ) {
                jQuery.map( filter_before[filter_by], function( elementOfArray, indexInArray ) {
                    if( elementOfArray == member_id ) {
                        in_array = true;
                    }
                });
            }

            if( in_array ) {
                return false;
            }

            filter[filter_by].push( member_id );

            jQuery.ajax({
                type: 'POST',
                url: ajax_url,
                data: 'action=wpc_message_get_filter_data&filter_by=' + filter_by + '&member_id=' + member_id,
                dataType: "json",
                success: function( data ){
                    if( !data.status ) {
                        alert( data.message );
                    } else {
                        jQuery( '.wpc_msg_active_filters_wrapper' ).append(
                            '<div class="wpc_filter_wrapper" data-filter_by="' + filter_by + '" data-member_id="' + member_id + '">' +
                                data.title + ': ' + data.name +
                                '<div class="wpc_remove_filter">&times;</div>' +
                            '</div>'
                        ).trigger( 'change' );
                    }
                }
            });

        } else if( filter_by == 'date' ) {
            filter[filter_by] = {
                'from': obj.parents( '.wpc_msg_filter' ).find('.from_date_field').next().val(),
                'to': obj.parents( '.wpc_msg_filter' ).find('.to_date_field').next().val()
            };

            jQuery.ajax({
                type: 'POST',
                url: ajax_url,
                data: 'action=wpc_message_get_filter_data&filter_by=' + filter_by + '&from=' + filter[filter_by]['from'] + '&to=' + filter[filter_by]['to'],
                dataType: "json",
                success: function( data ){
                    if( !data.status ) {
                        alert( data.message );
                    } else {
                        jQuery( '.wpc_msg_active_filters_wrapper' ).append(
                            '<div class="wpc_filter_wrapper" data-filter_by="' + filter_by + '">' +
                                data.title + ': ' + data.from + ' - ' + data.to +
                                '<div class="wpc_remove_filter">&times;</div>' +
                            '</div>'
                        ).trigger( 'change' );
                    }
                }
            });

            obj.parents( '.wpc_msg_filter' ).find('.wpc_msg_filter_by option[value="date"]').attr('disabled', true);
            obj.parents( '.wpc_msg_filter' ).find('.wpc_msg_filter_by option:not("disabled")').first().prop('selected', true);
            obj.parents( '.wpc_msg_filter' ).find('.wpc_msg_filter_by').trigger( 'change' );
        }

        jQuery('.wpc_msg_filter').removeClass( 'filter_opened' );
    });


    //remove filters
    jQuery( '.wpc_msg_content_wrapper' ).on( 'click', '.wpc_remove_filter', function() {
        var obj = jQuery(this);

        var filter_before = filter;

        var filter_by = obj.parents( '.wpc_filter_wrapper' ).data('filter_by');

        if( filter_by == 'member' ) {
            var member_id = obj.parents( '.wpc_filter_wrapper' ).data('member_id');

            var index = filter_before[filter_by].indexOf( member_id.toString() );
            if( index > -1 ) {
                filter[filter_by].splice( index, 1 );
            }
        } else if( filter_by == 'date' ) {
            delete filter.date;

            jQuery( '.wpc_msg_filter' ).find('.wpc_msg_filter_by option[value="date"]').attr('disabled', false);
            jQuery( '.wpc_msg_filter' ).find('.wpc_msg_filter_by').trigger( 'change' );
        }

        jQuery( '.wpc_msg_active_filters_wrapper' ).trigger( 'change' );
        obj.parents( '.wpc_filter_wrapper' ).remove();
    });




    // Toggle list table rows on small screens
    jQuery( '.wpc_msg_content_wrapper' ).on( 'click', '.toggle-row', function() {
        jQuery( this ).closest( 'tr' ).toggleClass( 'is-expanded' );
        resize_messages_content();
    });












    jQuery( '.wpc_tab_container_block' ).on( 'click', '.wpc_msg_new_message_button', function() {
        jQuery( '.add_new_message' ).show();
        jQuery( '.wpc_msg_top_nav_wrapper' ).hide();
        jQuery( '.wpc_msg_content_wrapper_inner' ).hide();
        jQuery( '.wpc_msg_chain_content' ).hide().html('');
    });


    jQuery( '.wpc_tab_container_block' ).on( 'click', '#back_new_message', function() {
        jQuery( '.add_new_message' ).hide();
        jQuery( '.wpc_msg_top_nav_wrapper' ).show();
        jQuery( '.wpc_msg_content_wrapper_inner' ).show();
        jQuery( '.wpc_msg_chain_content' ).hide();
    });


    jQuery( '.wpc_tab_container_block' ).on( 'click', '#back_answer', function() {
        jQuery('.wpc_msg_refresh_button[data-object="chains"]').trigger('click');

        jQuery( '.add_new_message' ).hide();
        jQuery( '.wpc_msg_top_nav_wrapper' ).show();
        jQuery( '.wpc_msg_content_wrapper_inner' ).show();
        jQuery( '.wpc_msg_chain_content' ).hide();
    });


    jQuery( '#new_message_to' ).wpc_select({
        search:true,
        opacity:'0.2'
    });

    jQuery( '#new_message_to' ).change( function() {
        var obj = jQuery(this);
        var connected_field = obj.parents( '.add_new_message' ).find( '#new_message_cc' ).parents( '.new_message_line' );

        if( obj.val() == null ) {
            obj.parents( '.add_new_message' ).find( '#new_message_cc' ).attr( 'disabled', true ).html('');
            obj.parents( '.add_new_message' ).find( '#new_message_cc' ).wpc_select('destroy', jQuery( '#new_message_cc' ).data('wpc_select_unique'));
            connected_field.hide();
            return false;
        }

        jQuery.ajax({
            type: 'POST',
            url: ajax_url,
            data: 'action=wpc_message_get_connected_members&to=' + jQuery.base64Encode( JSON.stringify( obj.val() ) ),
            dataType: "json",
            success: function( data ) {
                if( !data.status ) {
                    alert( data.message );
                } else {
                    if( data.selectbox_content.length > 0 ) {
                        obj.parents( '.add_new_message' ).find( '#new_message_cc' ).attr( 'disabled', false ).html( data.selectbox_content );

                        obj.parents( '.add_new_message' ).find( '#new_message_cc' ).wpc_select({
                            search:true,
                            opacity:'0.2',
                            onChangeValue:function() {
                                if( obj.parents( '.add_new_message' ).find( '#new_message_cc option:selected' ).length >= 1 ) {
                                    jQuery( '#new_message_to' ).wpc_select('disable', jQuery( '#new_message_to' ).data('wpc_select_unique'));
                                } else {
                                    jQuery( '#new_message_to' ).wpc_select('enable', jQuery( '#new_message_to' ).data('wpc_select_unique'));
                                }
                            }
                        });

                        connected_field.show();
                    } else {
                        obj.parents( '.add_new_message' ).find( '#new_message_cc' ).attr( 'disabled', true ).html('');
                        obj.parents( '.add_new_message' ).find( '#new_message_cc' ).wpc_select('destroy', jQuery( '#new_message_cc' ).data('wpc_select_unique'));
                        connected_field.hide();
                    }
                }
            }
        });
    });


    jQuery( '.wpc_tab_container_block' ).on( 'click', '.wp-list-table.messages tr:not(.no-items)', function() {
        if( loading ) {
            return false;
        }

        var obj = jQuery(this);
        var chain_id = obj.find( '.wpc_msg_item').val();

        jQuery( '.wpc_ajax_overflow' ).show();
        loading = true;
        jQuery.ajax({
            type: 'POST',
            url: ajax_url,
            data: 'action=wpc_message_get_chain&chain_id=' + chain_id,
            dataType: "json",
            success: function( data ) {
                if( !data.status ) {
                    jQuery( '.wpc_ajax_overflow' ).hide();
                    alert( data.message );
                } else {
                    jQuery( '.wpc_msg_chain_content' ).html( data.html).show();

                    jQuery( '.wpc_msg_top_nav_wrapper' ).hide();
                    jQuery( '.wpc_msg_content_wrapper_inner' ).hide();
                    jQuery( '.wpc_ajax_overflow' ).hide();
                }
                loading = false;
            }
        });
    });


    jQuery( '.wpc_msg_chain_content' ).on('click', '#send_answer', function() {
        if( loading ) {
            return false;
        }

        var obj = jQuery(this);
        var chain_id = obj.data( 'chain_id' );

        loading = true;
        jQuery.ajax({
            type: 'POST',
            url: ajax_url,
            data: 'action=wpc_message_reply&chain_id=' + chain_id + '&content=' + jQuery( '#answer_content' ).val() + '&cc_email=' + jQuery( '#answer_cc_email' ).val(),
            dataType: "json",
            success: function( data ) {
                if( !data.status ) {
                    jQuery( '.wpc_ajax_overflow' ).hide();
                    alert( data.message );
                } else {
                    jQuery( '.wpc_msg_chain_answer' ).before( data.html );
                    jQuery( '#answer_content').val('');
                    jQuery( '#answer_cc_email').val('');
                }
                loading = false;
            }
        });
    });

    jQuery( '.wpc_msg_chain_content' ).on( 'click', '.wpc_msg_collapse_button', function() {
        if( loading ) {
            return false;
        }
        var label = jQuery(this).attr('title');
        jQuery(this).attr( 'title', jQuery(this).data('alt_title') ).data( 'alt_title', label );

        if( jQuery(this).find('div').hasClass( 'wpc_msg_expand_image' ) ) {
            jQuery(this).find('div').toggleClass( 'wpc_msg_expand_image' ).toggleClass( 'wpc_msg_collapse_image' );
            jQuery( '.wpc_msg_message_line.wpc_msg_for_hidden').show();
            jQuery( '.expand_older_messages').hide();
        } else {
            jQuery(this).find('div').toggleClass( 'wpc_msg_expand_image' ).toggleClass( 'wpc_msg_collapse_image' );
            jQuery( '.wpc_msg_message_line.wpc_msg_for_hidden' ).hide();
            jQuery( '.expand_older_messages' ).show();
        }
    });

    jQuery( '.wpc_msg_chain_content' ).on( 'click', '.expand_older_messages', function() {
        jQuery('.wpc_msg_collapse_button').trigger('click');
    });


    jQuery( window ).resize( function() {
        resize_messages_content();
    });

    //back to top js
    var offset = 220;
    var duration = 500;
    jQuery( window ).scroll(function() {
        if (jQuery(this).scrollTop() > offset) {
            jQuery('.back-to-top').fadeIn(duration);
        } else {
            jQuery('.back-to-top').fadeOut(duration);
        }
    });

    jQuery( '.back-to-top' ).click(function(event) {
        event.preventDefault();
        jQuery( 'html, body' ).animate({scrollTop: 0}, duration);
        return false;
    });

    if( typeof( window.location.search ) !== 'undefined' ) {
        //parse GET parameters
        var get_attr = {};
        var get_str = window.location.search.substring(1).split("&");

        for (var i=0; i<get_str.length; i++) {
            var temp = get_str[i].split("=");
            get_attr[temp[0]] = temp[1];
        }

        if( typeof( get_attr.send_message ) !== 'undefined' ) {
            //open new message to client form
            jQuery('#new_message_to').find( 'option[value="' + get_attr.send_message + '"]' ).attr( 'selected', true ).prop( 'selected', true );
            jQuery('#new_message_to').wpc_select('load_values');
            jQuery('#new_message_to').trigger( 'change' );
            jQuery('#new_message').trigger( 'click' );
        } else if( typeof( get_attr.filter_client ) !== 'undefined' ) {
            //open new message to client form
            if( typeof one_time_filter === 'undefined' ) {
                one_time_filter = {};
            }

            if( !one_time_filter.hasOwnProperty( 'member' ) ) {
                one_time_filter['member'] = [];
            }

            one_time_filter['member'].push( get_attr.filter_client );

            jQuery( '.nav_button' ).first().trigger( 'click' );

            jQuery.ajax({
                type: 'POST',
                url: ajax_url,
                data: 'action=wpc_message_get_filter_data&filter_by=member&member_id=' + get_attr.filter_client,
                dataType: "json",
                success: function( data ){
                    if( !data.status ) {
                        alert( data.message );
                    } else {
                        jQuery( '.wpc_msg_active_filters_wrapper' ).append(
                            '<div class="wpc_filter_wrapper" data-filter_by="member" data-member_id="' + get_attr.filter_client + '">' +
                            data.title + ': ' + data.name +
                            '<div class="wpc_remove_filter">&times;</div>' +
                            '</div>'
                        );

                        jQuery( '.wpc_ajax_overflow' ).hide();
                    }
                }
            });
        } else {
            //first load trigger
            jQuery( '.nav_button' ).first().trigger( 'click' );
        }
    }

    function resize_messages_content() {
        jQuery( '.wpc_chain_subject' ).each( function() {
            jQuery(this).siblings( '.wpc_chain_last_message' ).css( 'width', 96 - Math.ceil((jQuery(this).width()*1) * 100/(jQuery(this).parent().width()*1)) + '%' );
        });
    }
});