jQuery(document).ready(function() {

    jQuery( '.wpc_img_file_icon' ).tooltip({
        items: "[wpc_images]",
        content: function() {
            var element = jQuery( this );
            if ( element.is( "[wpc_images]" ) ) {
                var text = element.attr( 'wpc_images' );
                return "<img alt='" + text +
                "' src='" +
                text + "'>";
            }
        }
    });

    jQuery( '.files_pagination_block' ).click( function() {
        var obj = jQuery(this);
        var files_form_id = obj.parents( '.wpc_client_files' ).data( 'form_id' );

        if( obj.parents( '.wpc_client_files' ).hasClass( 'wpc_fileslu_shortcode' ) ) {

            var shortcode_type = 'fileslu';
            var php_data = window['wpc_fileslu_pagination' + files_form_id];

        } else if( obj.parents( '.wpc_client_files' ).hasClass( 'wpc_filesla_shortcode' ) ) {

            var shortcode_type = 'filesla';
            var php_data = window['wpc_filesla_pagination' + files_form_id];
            var exclude_author = php_data.exclude_author;

        }

        if( php_data.client_id ) {
            var client_id = php_data.client_id;
            var _wpnonce = php_data._wpnonce;
        }

        var page_number = obj.data( 'page_number' );
        var last_category_id = obj.data( 'last_category_id' );

        if( obj.parents( '.wpc_client_files' ).find( '.sort_time_asc' ).hasClass( 'wpc_file_sorted' ) ) {
            var order_by = 'time';
            var order = 'asc';
        } else if( obj.parents( '.wpc_client_files' ).find( '.sort_time_desc' ).hasClass( 'wpc_file_sorted' ) ) {
            var order_by = 'time';
            var order = 'desc';
        } else if( obj.parents( '.wpc_client_files' ).find( '.sort_name_asc' ).hasClass( 'wpc_file_sorted' ) ) {
            var order_by = 'name';
            var order = 'asc';
        } else if( obj.parents( '.wpc_client_files' ).find( '.sort_name_desc' ).hasClass( 'wpc_file_sorted' ) ) {
            var order_by = 'name';
            var order = 'desc';
        } else {

            var order_by = obj.parents( '.wpc_client_files' ).find( '.wpc_default_sort_by' ).val();
            var order = obj.parents( '.wpc_client_files' ).find( '.wpc_default_sort' ).val();

        }

        obj.parents( '.wpc_client_files' ).find('.wpc_overlay').show();
        jQuery('body').css('cursor', 'wait');

        jQuery.ajax({
            type: 'POST',
            url: php_data.site_url + '/wp-admin/admin-ajax.php',
            data: 'action=wpc_files_shortcode_list_pagination&shortcode_type=' + shortcode_type + '&shortcode_data=' + JSON.stringify( php_data.data ) + '&current_page=' + page_number + '&last_category_id=' + last_category_id + '&show_by=' + php_data.show_by + '&exclude_author=' + exclude_author + '&sort=' + order_by + '&dir=' + order + '&client_id=' + client_id + '&security=' + _wpnonce,
            dataType: "json",
            success: function( data ){
                if( !data.status ) {
                    alert( data.message );
                } else {

                    obj.parents( '.wpc_client_files' ).find( '.file_item:last' ).after( data.html );
                    obj.data( 'page_number', obj.data( 'page_number' )*1 + 1 );
                    obj.data( 'last_category_id', data.last_category_id );

                    if( !data.pagination ) {
                        obj.hide();
                    }

                    jQuery( '.wpc_img_file_icon' ).tooltip({
                        items: "[wpc_images]",
                        content: function() {
                            var element = jQuery( this );
                            if ( element.is( "[wpc_images]" ) ) {
                                var text = element.attr( 'wpc_images' );
                                return "<img alt='" + text +
                                "' src='" +
                                text + "'>";
                            }
                        }
                    });
                }

                obj.parents( '.wpc_client_files' ).find('.wpc_overlay').hide();
                jQuery('body').css( 'cursor', 'default' );
            }
        });

    });


    jQuery( '.sort_time_asc.wpc_js_sort' ).click( function() {

        var order_by = 'time';
        var order = 'asc';

        var obj = jQuery(this);
        var files_form_id = obj.parents( '.wpc_client_files' ).data( 'form_id' );

        if( obj.parents( '.wpc_client_files' ).hasClass( 'wpc_fileslu_shortcode' ) ) {

            var shortcode_type = 'fileslu';
            var php_data = window['wpc_fileslu_pagination' + files_form_id];

        } else if( obj.parents( '.wpc_client_files' ).hasClass( 'wpc_filesla_shortcode' ) ) {

            var shortcode_type = 'filesla';
            var php_data = window['wpc_filesla_pagination' + files_form_id];
            var exclude_author = php_data.exclude_author;

        }

        if( php_data.client_id ) {
            var client_id = php_data.client_id;
            var _wpnonce = php_data._wpnonce;
        }

        obj.parents( '.wpc_client_files' ).find('.wpc_overlay').show();
        jQuery('body').css('cursor', 'wait');

        jQuery.ajax({
            type: 'POST',
            url: php_data.site_url + '/wp-admin/admin-ajax.php',
            data: 'action=wpc_files_shortcode_list_pagination&shortcode_type=' + shortcode_type + '&shortcode_data=' + JSON.stringify( php_data.data ) + '&current_page=0&last_category_id=0&show_by=' + php_data.show_by + '&exclude_author=' + exclude_author + '&sort=' + order_by + '&dir=' + order + '&client_id=' + client_id + '&security=' + _wpnonce,
            dataType: "json",
            success: function( data ){
                if( !data.status ) {
                    alert( data.message );
                } else {
                    obj.parents( '.wpc_client_files' ).find( '.file_item' ).remove();
                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').before( data.html );

                    if( obj.parents( '.wpc_client_files' ).find( '.sort_time_asc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_time_asc' ).removeClass( 'wpc_file_sorted' );
                    } else if( obj.parents( '.wpc_client_files' ).find( '.sort_time_desc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_time_desc' ).removeClass( 'wpc_file_sorted' );
                    } else if( obj.parents( '.wpc_client_files' ).find( '.sort_name_asc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_name_asc' ).removeClass( 'wpc_file_sorted' );
                    } else if( obj.parents( '.wpc_client_files' ).find( '.sort_name_desc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_name_desc' ).removeClass( 'wpc_file_sorted' );
                    }

                    obj.addClass( 'wpc_file_sorted' );
                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').data( 'page_number', '1' );
                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').data( 'last_category_id', data.last_category_id );
                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').show();

                    if( !data.pagination ) {
                        obj.parents( '.wpc_client_files' ).find('.files_pagination_block').hide();
                    }

                    jQuery( '.wpc_img_file_icon' ).tooltip({
                        items: "[wpc_images]",
                        content: function() {
                            var element = jQuery( this );
                            if ( element.is( "[wpc_images]" ) ) {
                                var text = element.attr( 'wpc_images' );
                                return "<img alt='" + text +
                                "' src='" +
                                text + "'>";
                            }
                        }
                    });
                }

                obj.parents( '.wpc_client_files' ).find('.wpc_overlay').hide();
                jQuery('body').css( 'cursor', 'default' );
            }
        });
    });


    jQuery( '.sort_time_desc.wpc_js_sort' ).click( function() {

        var order_by = 'time';
        var order = 'desc';

        var obj = jQuery(this);
        var files_form_id = obj.parents( '.wpc_client_files' ).data( 'form_id' );

        if( obj.parents( '.wpc_client_files' ).hasClass( 'wpc_fileslu_shortcode' ) ) {

            var shortcode_type = 'fileslu';
            var php_data = window['wpc_fileslu_pagination' + files_form_id];

        } else if( obj.parents( '.wpc_client_files' ).hasClass( 'wpc_filesla_shortcode' ) ) {

            var shortcode_type = 'filesla';
            var php_data = window['wpc_filesla_pagination' + files_form_id];
            var exclude_author = php_data.exclude_author;

        }

        if( php_data.client_id ) {
            var client_id = php_data.client_id;
            var _wpnonce = php_data._wpnonce;
        }

        obj.parents( '.wpc_client_files' ).find('.wpc_overlay').show();
        jQuery('body').css('cursor', 'wait');

        jQuery.ajax({
            type: 'POST',
            url: php_data.site_url + '/wp-admin/admin-ajax.php',
            data: 'action=wpc_files_shortcode_list_pagination&shortcode_type=' + shortcode_type + '&shortcode_data=' + JSON.stringify( php_data.data ) + '&current_page=0&last_category_id=0&show_by=' + php_data.show_by + '&exclude_author=' + exclude_author + '&sort=' + order_by + '&dir=' + order + '&client_id=' + client_id + '&security=' + _wpnonce,
            dataType: "json",
            success: function( data ){
                if( !data.status ) {
                    alert( data.message );
                } else {

                    obj.parents( '.wpc_client_files' ).find( '.file_item' ).remove();
                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').before( data.html );

                    if( obj.parents( '.wpc_client_files' ).find( '.sort_time_asc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_time_asc' ).removeClass( 'wpc_file_sorted' );
                    } else if( obj.parents( '.wpc_client_files' ).find( '.sort_time_desc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_time_desc' ).removeClass( 'wpc_file_sorted' );
                    } else if( obj.parents( '.wpc_client_files' ).find( '.sort_name_asc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_name_asc' ).removeClass( 'wpc_file_sorted' );
                    } else if( obj.parents( '.wpc_client_files' ).find( '.sort_name_desc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_name_desc' ).removeClass( 'wpc_file_sorted' );
                    }

                    obj.addClass('wpc_file_sorted');
                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').data( 'page_number', '1' );
                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').data( 'last_category_id', data.last_category_id );

                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').show();
                    if( !data.pagination ) {
                        obj.parents( '.wpc_client_files' ).find('.files_pagination_block').hide();
                    }

                    jQuery( '.wpc_img_file_icon' ).tooltip({
                        items: "[wpc_images]",
                        content: function() {
                            var element = jQuery( this );
                            if ( element.is( "[wpc_images]" ) ) {
                                var text = element.attr( 'wpc_images' );
                                return "<img alt='" + text +
                                "' src='" +
                                text + "'>";
                            }
                        }
                    });
                }

                obj.parents( '.wpc_client_files' ).find('.wpc_overlay').hide();
                jQuery('body').css( 'cursor', 'default' );
            }
        });
    });


    jQuery( '.sort_name_asc.wpc_js_sort' ).click( function() {

        var order_by = 'title';
        var order = 'asc';

        var obj = jQuery(this);
        var files_form_id = obj.parents( '.wpc_client_files' ).data( 'form_id' );

        if( obj.parents( '.wpc_client_files' ).hasClass( 'wpc_fileslu_shortcode' ) ) {

            var shortcode_type = 'fileslu';
            var php_data = window['wpc_fileslu_pagination' + files_form_id];

        } else if( obj.parents( '.wpc_client_files' ).hasClass( 'wpc_filesla_shortcode' ) ) {

            var shortcode_type = 'filesla';
            var php_data = window['wpc_filesla_pagination' + files_form_id];
            var exclude_author = php_data.exclude_author;

        }

        if( php_data.client_id ) {
            var client_id = php_data.client_id;
            var _wpnonce = php_data._wpnonce;
        }

        obj.parents( '.wpc_client_files' ).find('.wpc_overlay').show();
        jQuery('body').css('cursor', 'wait');

        jQuery.ajax({
            type: 'POST',
            url: php_data.site_url + '/wp-admin/admin-ajax.php',
            data: 'action=wpc_files_shortcode_list_pagination&shortcode_type=' + shortcode_type + '&shortcode_data=' + JSON.stringify( php_data.data ) + '&current_page=0&last_category_id=0&show_by=' + php_data.show_by + '&exclude_author=' + exclude_author + '&sort=' + order_by + '&dir=' + order + '&client_id=' + client_id + '&security=' + _wpnonce,
            dataType: "json",
            success: function( data ){
                if( !data.status ) {
                    alert( data.message );
                } else {

                    obj.parents( '.wpc_client_files' ).find( '.file_item' ).remove();
                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').before( data.html );

                    if( obj.parents( '.wpc_client_files' ).find( '.sort_time_asc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_time_asc' ).removeClass( 'wpc_file_sorted' );
                    } else if( obj.parents( '.wpc_client_files' ).find( '.sort_time_desc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_time_desc' ).removeClass( 'wpc_file_sorted' );
                    } else if( obj.parents( '.wpc_client_files' ).find( '.sort_name_asc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_name_asc' ).removeClass( 'wpc_file_sorted' );
                    } else if( obj.parents( '.wpc_client_files' ).find( '.sort_name_desc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_name_desc' ).removeClass( 'wpc_file_sorted' );
                    }

                    obj.addClass('wpc_file_sorted');
                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').data( 'page_number', '1' );
                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').data( 'last_category_id', data.last_category_id );

                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').show();
                    if( !data.pagination ) {
                        obj.parents( '.wpc_client_files' ).find('.files_pagination_block').hide();
                    }

                    jQuery( '.wpc_img_file_icon' ).tooltip({
                        items: "[wpc_images]",
                        content: function() {
                            var element = jQuery( this );
                            if ( element.is( "[wpc_images]" ) ) {
                                var text = element.attr( 'wpc_images' );
                                return "<img alt='" + text +
                                "' src='" +
                                text + "'>";
                            }
                        }
                    });
                }

                obj.parents( '.wpc_client_files' ).find('.wpc_overlay').hide();
                jQuery('body').css( 'cursor', 'default' );
            }
        });
    });


    jQuery( '.sort_name_desc.wpc_js_sort' ).click( function() {

        var order_by = 'title';
        var order = 'desc';

        var obj = jQuery(this);
        var files_form_id = obj.parents( '.wpc_client_files' ).data( 'form_id' );

        if( obj.parents( '.wpc_client_files' ).hasClass( 'wpc_fileslu_shortcode' ) ) {

            var shortcode_type = 'fileslu';
            var php_data = window['wpc_fileslu_pagination' + files_form_id];

        } else if( obj.parents( '.wpc_client_files' ).hasClass( 'wpc_filesla_shortcode' ) ) {

            var shortcode_type = 'filesla';
            var php_data = window['wpc_filesla_pagination' + files_form_id];
            var exclude_author = php_data.exclude_author;

        }

        if( php_data.client_id ) {
            var client_id = php_data.client_id;
            var _wpnonce = php_data._wpnonce;
        }

        obj.parents( '.wpc_client_files' ).find('.wpc_overlay').show();
        jQuery('body').css('cursor', 'wait');

        jQuery.ajax({
            type: 'POST',
            url: php_data.site_url + '/wp-admin/admin-ajax.php',
            data: 'action=wpc_files_shortcode_list_pagination&shortcode_type=' + shortcode_type + '&shortcode_data=' + JSON.stringify( php_data.data ) + '&current_page=0&last_category_id=0&show_by=' + php_data.show_by + '&exclude_author=' + exclude_author + '&sort=' + order_by + '&dir=' + order + '&client_id=' + client_id + '&security=' + _wpnonce,
            dataType: "json",
            success: function( data ){
                if( !data.status ) {
                    alert( data.message );
                } else {

                    obj.parents( '.wpc_client_files' ).find( '.file_item' ).remove();
                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').before( data.html );

                    if( obj.parents( '.wpc_client_files' ).find( '.sort_time_asc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_time_asc' ).removeClass( 'wpc_file_sorted' );
                    } else if( obj.parents( '.wpc_client_files' ).find( '.sort_time_desc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_time_desc' ).removeClass( 'wpc_file_sorted' );
                    } else if( obj.parents( '.wpc_client_files' ).find( '.sort_name_asc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_name_asc' ).removeClass( 'wpc_file_sorted' );
                    } else if( obj.parents( '.wpc_client_files' ).find( '.sort_name_desc' ).hasClass( 'wpc_file_sorted' ) ) {
                        obj.parents( '.wpc_client_files' ).find( '.sort_name_desc' ).removeClass( 'wpc_file_sorted' );
                    }

                    obj.addClass('wpc_file_sorted');
                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').data( 'page_number', '1' );
                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').data( 'last_category_id', data.last_category_id );

                    obj.parents( '.wpc_client_files' ).find('.files_pagination_block').show();
                    if( !data.pagination ) {
                        obj.parents( '.wpc_client_files' ).find('.files_pagination_block').hide();
                    }

                    jQuery( '.wpc_img_file_icon' ).tooltip({
                        items: "[wpc_images]",
                        content: function() {
                            var element = jQuery( this );
                            if ( element.is( "[wpc_images]" ) ) {
                                var text = element.attr( 'wpc_images' );
                                return "<img alt='" + text +
                                "' src='" +
                                text + "'>";
                            }
                        }
                    });
                }

                obj.parents( '.wpc_client_files' ).find('.wpc_overlay').hide();
                jQuery('body').css( 'cursor', 'default' );
            }
        });
    });

});
