jQuery(document).ready(function() {

    jQuery( '.wpc_img_file_icon' ).tooltip({
        items: "[wpc_images]",
        content: function() {
            var element = jQuery( this );
            if ( element.is( "[wpc_images]" ) ) {
                var text = element.attr( 'wpc_images' );
                return "<img alt='" + text + "' src='" + text + "'>";
            }
        }
    });


    // We need to rework the sizes so they are actually sortable
    jQuery('td.size').each(function() {
        var size = jQuery(this).attr('data-size').split(' ');
        var multiplier = 1;
        switch(size[1]) {
            case 'K':
                multiplier = 1000;
                break;
            case 'MB':
                multiplier = 1000000;
                break;
            case 'G':
                multiplier = 1000000000;
                break;
        }
        jQuery(this).attr('data-size', Math.round(parseFloat(size[0]) * multiplier) );

    });


    jQuery( '.wpc_client_files th.wpc_sortable' ).on( 'click', function() {
        var obj = jQuery(this);
        var clsName = obj.find( '.wpc_cust_file_sort' ).attr('class').match(/\w*wpc_cust_sort_\w*/)[0].replace('wpc_cust_sort_','');


        var page_number = obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_active_page' ).html();
        if( typeof page_number === 'undefined' ) {
            page_number = '1';
        }

        var search = obj.parents( '.wpc_client_files_table' ).find( '.wpc_files_search.wpc_searched' ).val();

        if( typeof search === "undefined") {
            search = '';
        }

        var exclude_author = '';
        var client_id  = 0;
        var _wpnonce = '';

        var files_form_id = obj.parents( '.wpc_client_files_table' ).data( 'form_id' );

        if( obj.parents( '.wpc_client_files_table' ).hasClass( 'wpc_fileslu_shortcode' ) ) {

            var shortcode_type = 'fileslu';
            var php_data = window['wpc_fileslu_pagination' + files_form_id];

        } else if( obj.parents( '.wpc_client_files_table' ).hasClass( 'wpc_filesla_shortcode' ) ) {

            var shortcode_type = 'filesla';
            var php_data = window['wpc_filesla_pagination' + files_form_id];
            var exclude_author = php_data.exclude_author;

        }

        if( php_data.client_id ) {
            var client_id = php_data.client_id;
            var _wpnonce = php_data._wpnonce;
        }

        var category_filter = obj.parents( '.wpc_client_files_table' ).find( '.wpc_files_filter.wpc_filtered' ).val();

        if( typeof category_filter === "undefined" ) {
            category_filter = 'all';
        }

        if( obj.hasClass( 'wpc_sort_asc' ) ) {

            var order_by = clsName;
            var order = 'desc';

        } else if( obj.hasClass( 'wpc_sort_desc' ) ) {

            var order_by = clsName;
            var order = 'asc';

        } else if( !obj.hasClass( 'wpc_sort_desc' ) && !obj.hasClass( 'wpc_sort_asc' ) ) {

            var order_by = clsName;
            var order = 'asc';
        }


        jQuery.ajax({
            type: 'POST',
            url: php_data.site_url + '/wp-admin/admin-ajax.php',
            data: 'action=wpc_files_shortcode_pagination&shortcode_type=' + shortcode_type + '&shortcode_data=' + JSON.stringify( php_data.data ) + '&category_id=' + category_filter + '&search=' + search + '&current_page=' + page_number + '&show_by=' + php_data.show_by + '&exclude_author=' + exclude_author + '&order_by=' + order_by + '&order=' + order + '&client_id=' + client_id + '&security=' + _wpnonce,
            dataType: "json",
            success: function( data ){
                if( !data.status ) {
                    alert( data.message );
                } else {

                    obj.parents( '.wpc_client_files_table' ).find( 'tbody' ).html( data.html );

                    if( obj.hasClass( 'wpc_sort_asc' ) ) {
                        obj.parents( '.wpc_client_files' ).find('th.wpc_sortable').removeClass('wpc_sort_asc').removeClass('wpc_sort_desc');
                        obj.parents( '.wpc_client_files' ).find( '.wpc_cust_sort_' + clsName ).parents('th.wpc_sortable').addClass( 'wpc_sort_desc' );


                    } else if( obj.hasClass( 'wpc_sort_desc' ) ) {
                        obj.parents( '.wpc_client_files' ).find('th.wpc_sortable').removeClass('wpc_sort_asc').removeClass('wpc_sort_desc');
                        obj.parents( '.wpc_client_files' ).find( '.wpc_cust_sort_' + clsName ).parents('th.wpc_sortable').addClass( 'wpc_sort_asc' );


                    } else if( !obj.hasClass( 'wpc_sort_desc' ) && !obj.hasClass( 'wpc_sort_asc' ) ) {
                        obj.parents( '.wpc_client_files' ).find('th.wpc_sortable').removeClass('wpc_sort_asc').removeClass('wpc_sort_desc');
                        obj.addClass( 'wpc_sort_asc' );
                    }

                    jQuery( '.wpc_img_file_icon' ).tooltip({
                        items: "[wpc_images]",
                        content: function() {
                            var element = jQuery( this );
                            if ( element.is( "[wpc_images]" ) ) {
                                var text = element.attr( 'wpc_images' );
                                return "<img alt='" + text +
                                "' src='" +
                                text + "'>";
                            }
                        }
                    });
                }
            }
        });

    });


    jQuery( '.wpc_files_search_button' ).click( function() {
        var obj = jQuery(this);

        var exclude_author = '';
        var client_id  = 0;
        var _wpnonce = '';

        var files_form_id = obj.parents( '.wpc_client_files_table' ).data( 'form_id' );

        if( obj.parents( '.wpc_client_files_table' ).hasClass( 'wpc_fileslu_shortcode' ) ) {

            var shortcode_type = 'fileslu';
            var php_data = window['wpc_fileslu_pagination' + files_form_id];

        } else if( obj.parents( '.wpc_client_files_table' ).hasClass( 'wpc_filesla_shortcode' ) ) {

            var shortcode_type = 'filesla';
            var php_data = window['wpc_filesla_pagination' + files_form_id];
            var exclude_author = php_data.exclude_author;

        }

        if( php_data.client_id ) {
            var client_id = php_data.client_id;
            var _wpnonce = php_data._wpnonce;
        }

        var search = jQuery.trim( obj.parents( '.wpc_client_files_table' ).find( '.wpc_files_search' ).val() );
        if( search == '' ) {
            return false;
        }

        var category_id = obj.parents( '.wpc_client_files_table' ).find( '.wpc_files_filter.wpc_filtered' ).val();

        if( typeof category_id === "undefined" ) {
            category_id = 'all';
        }

        jQuery.ajax({
            type: 'POST',
            url: php_data.site_url + '/wp-admin/admin-ajax.php',
            data: 'action=wpc_files_shortcode_pagination&shortcode_type=' + shortcode_type + '&shortcode_data=' + JSON.stringify( php_data.data ) + '&category_id=' + category_id + '&search=' + search + '&show_by=' + php_data.show_by + '&exclude_author=' + exclude_author + '&client_id=' + client_id + '&security=' + _wpnonce,
            dataType: "json",
            success: function( data ){
                if( !data.status ) {
                    alert( data.message );
                } else {

                    obj.parents( '.wpc_client_files_table' ).find( 'tbody' ).html( data.html );

                    if( data.filter_html !== false ) {
                        obj.parents( '.wpc_client_files_table' ).find('.wpc_files_filter').html( data.filter_html );
                    } else {
                        obj.parents( '.wpc_client_files_table' ).find('.wpc_files_filter_block').hide();
                    }

                    if( php_data.data.show_pagination ) {
                        var pagination_html = '';

                        pagination_html += '<span class="wpc_files_counter">' + data.pagination.files_count + '</span>'
                        if( data.pagination.count_pages > 1 ) {
                            pagination_html +='<a href="javascript:void(0);" class="wpc_pagination_links wpc_first" style="display:none;"> << </a>' +
                            '<a href="javascript:void(0);" class="wpc_pagination_links wpc_previous" style="display:none;"> < </a>' +
                            '<a href="javascript:void(0);" class="wpc_pagination_links wpc_previous_pages" style="display:none;"> ... </a>' +
                            '<a href="javascript:void(0);" class="wpc_pagination_links wpc_active_page"> 1 </a>';
                            if( data.pagination.count_pages <= 3 ) {
                                for( var i = 2; i <= data.pagination.count_pages; i++ ) {
                                    pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links"> ' + i + ' </a>';
                                }
                            } else if ( data.pagination.count_pages > 3 ) {
                                for( var i = 2; i <= 3; i++ ) {
                                    pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links"> ' + i + ' </a>';
                                }
                                for( var i = 4; i <= data.pagination.count_pages; i++ ) {
                                    pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links" style="display:none;"> ' + i + ' </a>';
                                }
                                pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links wpc_next_pages"> ... </a>';
                            }
                            pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links wpc_next"> > </a>' +
                            '<a href="javascript:void(0);" class="wpc_pagination_links wpc_last"> >> </a>';
                        }

                        obj.parents( '.wpc_client_files_table' ).find( '.wpc_files_pagination' ).html( pagination_html );
                        php_data.count_pages = data.pagination.count_pages;
                    }

                    obj.siblings( '.wpc_files_search' ).addClass( 'wpc_searched' );
                    obj.parents( '.wpc_client_files_table' ).find('.wpc_files_clear_search' ).show();
                    obj.parents( '.wpc_client_files_table' ).find('th.wpc_sortable').removeClass('wpc_sort_asc').removeClass('wpc_sort_desc');

                    jQuery( '.wpc_img_file_icon' ).tooltip({
                        items: "[wpc_images]",
                        content: function() {
                            var element = jQuery( this );
                            if ( element.is( "[wpc_images]" ) ) {
                                var text = element.attr( 'wpc_images' );
                                return "<img alt='" + text +
                                "' src='" +
                                text + "'>";
                            }
                        }
                    });
                }
            }
        });
    });


    jQuery( '.wpc_files_clear_search' ).click( function() {
        var obj = jQuery(this);

        var exclude_author = '';
        var client_id  = 0;
        var _wpnonce = '';

        var files_form_id = obj.parents( '.wpc_client_files_table' ).data( 'form_id' );

        if( obj.parents( '.wpc_client_files_table' ).hasClass( 'wpc_fileslu_shortcode' ) ) {

            var shortcode_type = 'fileslu';
            var php_data = window['wpc_fileslu_pagination' + files_form_id];

        } else if( obj.parents( '.wpc_client_files_table' ).hasClass( 'wpc_filesla_shortcode' ) ) {

            var shortcode_type = 'filesla';
            var php_data = window['wpc_filesla_pagination' + files_form_id];
            var exclude_author = php_data.exclude_author;

        }

        if( php_data.client_id ) {
            var client_id = php_data.client_id;
            var _wpnonce = php_data._wpnonce;
        }

        var search = '';

        var category_id = obj.parents( '.wpc_client_files_table' ).find( '.wpc_files_filter.wpc_filtered' ).val();

        if( typeof category_id === "undefined" ) {
            category_id = 'all';
        }

        jQuery.ajax({
            type: 'POST',
            url: php_data.site_url + '/wp-admin/admin-ajax.php',
            data: 'action=wpc_files_shortcode_pagination&shortcode_type=' + shortcode_type + '&shortcode_data=' + JSON.stringify( php_data.data ) + '&category_id=' + category_id + '&search=' + search + '&show_by=' + php_data.show_by + '&exclude_author=' + exclude_author + '&client_id=' + client_id + '&security=' + _wpnonce,
            dataType: "json",
            success: function( data ){
                if( !data.status ) {
                    alert( data.message );
                } else {

                    obj.parents( '.wpc_client_files_table' ).find( 'tbody' ).html( data.html );

                    if( data.filter_html !== false ) {
                        obj.parents( '.wpc_client_files_table' ).find('.wpc_files_filter').html( data.filter_html );
                    } else {
                        obj.parents( '.wpc_client_files_table' ).find('.wpc_files_filter_block').hide();
                    }

                    if( php_data.data.show_pagination ) {
                        var pagination_html = '';

                        pagination_html += '<span class="wpc_files_counter">' + data.pagination.files_count + '</span>'
                        if( data.pagination.count_pages > 1 ) {
                            pagination_html +='<a href="javascript:void(0);" class="wpc_pagination_links wpc_first" style="display:none;"> << </a>' +
                            '<a href="javascript:void(0);" class="wpc_pagination_links wpc_previous" style="display:none;"> < </a>' +
                            '<a href="javascript:void(0);" class="wpc_pagination_links wpc_previous_pages" style="display:none;"> ... </a>' +
                            '<a href="javascript:void(0);" class="wpc_pagination_links wpc_active_page"> 1 </a>';
                            if( data.pagination.count_pages <= 3 ) {
                                for( var i = 2; i <= data.pagination.count_pages; i++ ) {
                                    pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links"> ' + i + ' </a>';
                                }
                            } else if ( data.pagination.count_pages > 3 ) {
                                for( var i = 2; i <= 3; i++ ) {
                                    pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links"> ' + i + ' </a>';
                                }
                                for( var i = 4; i <= data.pagination.count_pages; i++ ) {
                                    pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links" style="display:none;"> ' + i + ' </a>';
                                }
                                pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links wpc_next_pages"> ... </a>';
                            }
                            pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links wpc_next"> > </a>' +
                            '<a href="javascript:void(0);" class="wpc_pagination_links wpc_last"> >> </a>';
                        }

                        obj.parents( '.wpc_client_files_table' ).find( '.wpc_files_pagination' ).html( pagination_html );
                        php_data.count_pages = data.pagination.count_pages;
                    }

                    obj.siblings( '.wpc_files_search' ).removeClass( 'wpc_searched' ).val('');
                    obj.parents( '.wpc_client_files_table' ).find('.wpc_files_clear_search' ).hide();
                    obj.parents( '.wpc_client_files_table' ).find('th.wpc_sortable').removeClass('wpc_sort_asc').removeClass('wpc_sort_desc');

                    jQuery( '.wpc_img_file_icon' ).tooltip({
                        items: "[wpc_images]",
                        content: function() {
                            var element = jQuery( this );
                            if ( element.is( "[wpc_images]" ) ) {
                                var text = element.attr( 'wpc_images' );
                                return "<img alt='" + text +
                                "' src='" +
                                text + "'>";
                            }
                        }
                    });
                }
            }
        });
    });


    jQuery( '.wpc_files_filter_button' ).click( function() {
        var obj = jQuery(this);

        var exclude_author = '';
        var client_id  = 0;
        var _wpnonce = '';

        var files_form_id = obj.parents( '.wpc_client_files_table' ).data( 'form_id' );

        if( obj.parents( '.wpc_client_files_table' ).hasClass( 'wpc_fileslu_shortcode' ) ) {

            var shortcode_type = 'fileslu';
            var php_data = window['wpc_fileslu_pagination' + files_form_id];

        } else if( obj.parents( '.wpc_client_files_table' ).hasClass( 'wpc_filesla_shortcode' ) ) {

            var shortcode_type = 'filesla';
            var php_data = window['wpc_filesla_pagination' + files_form_id];
            var exclude_author = php_data.exclude_author;

        }

        if( php_data.client_id ) {
            var client_id = php_data.client_id;
            var _wpnonce = php_data._wpnonce;
        }

        var category_id = obj.parents( '.wpc_files_filter_block' ).find('.wpc_files_filter').val();
        if( category_id == 'all' && !obj.siblings( '.wpc_files_filter' ).hasClass( 'wpc_filtered' ) ) {
            return false;
        }

        var search = obj.parents( '.wpc_client_files_table' ).find( '.wpc_files_search.wpc_searched' ).val();

        if( typeof search === "undefined") {
            search = '';
        }

        jQuery.ajax({
            type: 'POST',
            url: php_data.site_url + '/wp-admin/admin-ajax.php',
            data: 'action=wpc_files_shortcode_pagination&shortcode_type=' + shortcode_type + '&shortcode_data=' + JSON.stringify( php_data.data ) + '&category_id=' + category_id + '&search=' + search + '&show_by=' + php_data.show_by + '&exclude_author=' + exclude_author + '&client_id=' + client_id + '&security=' + _wpnonce,
            dataType: "json",
            success: function( data ){
                if( !data.status ) {
                    alert( data.message );
                } else {

                    obj.parents( '.wpc_client_files_table' ).find( 'tbody' ).html( data.html );

                    if( php_data.data.show_pagination ) {
                        var pagination_html = '';

                        pagination_html += '<span class="wpc_files_counter">' + data.pagination.files_count + '</span>'
                        if( data.pagination.count_pages > 1 ) {
                            pagination_html +='<a href="javascript:void(0);" class="wpc_pagination_links wpc_first" style="display:none;"> << </a>' +
                            '<a href="javascript:void(0);" class="wpc_pagination_links wpc_previous" style="display:none;"> < </a>' +
                            '<a href="javascript:void(0);" class="wpc_pagination_links wpc_previous_pages" style="display:none;"> ... </a>' +
                            '<a href="javascript:void(0);" class="wpc_pagination_links wpc_active_page"> 1 </a>';
                            if( data.pagination.count_pages <= 3 ) {
                                for( var i = 2; i <= data.pagination.count_pages; i++ ) {
                                    pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links"> ' + i + ' </a>';
                                }
                            } else if ( data.pagination.count_pages > 3 ) {
                                for( var i = 2; i <= 3; i++ ) {
                                    pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links"> ' + i + ' </a>';
                                }
                                for( var i = 4; i <= data.pagination.count_pages; i++ ) {
                                    pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links" style="display:none;"> ' + i + ' </a>';
                                }
                                pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links wpc_next_pages"> ... </a>';
                            }
                            pagination_html += '<a href="javascript:void(0);" class="wpc_pagination_links wpc_next"> > </a>' +
                            '<a href="javascript:void(0);" class="wpc_pagination_links wpc_last"> >> </a>';
                        }

                        obj.parents( '.wpc_client_files_table' ).find( '.wpc_files_pagination' ).html( pagination_html );
                        php_data.count_pages = data.pagination.count_pages;
                    }


                    obj.siblings( '.wpc_files_filter' ).addClass('wpc_filtered');

                    obj.parents( '.wpc_client_files_table' ).find('th.wpc_sortable').removeClass('wpc_sort_asc').removeClass('wpc_sort_desc');

                    jQuery( '.wpc_img_file_icon' ).tooltip({
                        items: "[wpc_images]",
                        content: function() {
                            var element = jQuery( this );
                            if ( element.is( "[wpc_images]" ) ) {
                                var text = element.attr( 'wpc_images' );
                                return "<img alt='" + text +
                                "' src='" +
                                text + "'>";
                            }
                        }
                    });
                }
            }
        });

    });


    jQuery( '.wpc_client_files_table' ).on( 'click', 'a.wpc_pagination_links', function() {
        var obj = jQuery(this);
        var page_number = '';

        if( obj.hasClass( 'wpc_active_page' ) ) {
            return false;
        }

        var exclude_author = '';
        var client_id  = 0;
        var _wpnonce = '';

        var files_form_id = obj.parents( '.wpc_client_files_table' ).data( 'form_id' );

        if( obj.parents( '.wpc_client_files_table' ).hasClass( 'wpc_fileslu_shortcode' ) ) {

            var shortcode_type = 'fileslu';
            var php_data = window['wpc_fileslu_pagination' + files_form_id];

        } else if( obj.parents( '.wpc_client_files_table' ).hasClass( 'wpc_filesla_shortcode' ) ) {

            var shortcode_type = 'filesla';
            var php_data = window['wpc_filesla_pagination' + files_form_id];
            var exclude_author = php_data.exclude_author;

        }

        if( php_data.client_id ) {
            var client_id = php_data.client_id;
            var _wpnonce = php_data._wpnonce;
        }

        var category_filter = obj.parents( '.wpc_client_files_table' ).find( '.wpc_files_filter.wpc_filtered' ).val();

        if( typeof category_filter === "undefined" ) {
            category_filter = 'all';
        }

        var search = obj.parents( '.wpc_client_files_table' ).find( '.wpc_files_search.wpc_searched' ).val();

        if( typeof search === "undefined") {
            search = '';
        }

        var order_by = '';
        var order = '';
        obj.parents( '.wpc_client_files_table' ).find( '.wpc_client_files th.wpc_sortable' ).each( function(){
            if( jQuery(this).hasClass( 'wpc_sort_desc' ) ) {

                var clsName = jQuery(this).find( '.wpc_cust_file_sort' ).attr('class').match(/\w*wpc_cust_sort_\w*/)[0].replace('wpc_cust_sort_','');
                order_by = clsName;
                order = 'desc';

            } else if( jQuery(this).hasClass( 'wpc_sort_asc' ) ) {

                var clsName = jQuery(this).find( '.wpc_cust_file_sort' ).attr('class').match(/\w*wpc_cust_sort_\w*/)[0].replace('wpc_cust_sort_','');
                order_by = clsName;
                order = 'asc';

            }
        });


        if( obj.hasClass( 'wpc_last' ) ) {
            page_number = php_data.count_pages;
        } else if( obj.hasClass( 'wpc_first' ) ) {
            page_number = 1;
        } else if( obj.hasClass( 'wpc_next' ) ) {
            page_number = obj.siblings('.wpc_active_page').html()*1 + 1;
        } else if( obj.hasClass( 'wpc_previous' ) ) {
            page_number = obj.siblings('.wpc_active_page').html()*1 - 1;
        } else if( obj.hasClass( 'wpc_next_pages' ) )  {
            page_number = ( Math.floor( ( obj.siblings('.wpc_active_page').html()*1 - 1 ) / 3 ) + 1 )*3 + 1;
        } else if( obj.hasClass( 'wpc_previous_pages' ) ) {
            page_number = ( Math.floor( ( obj.siblings('.wpc_active_page').html()*1 - 1 ) / 3 ) )*3;
        } else {
            page_number = obj.html()*1;
        }


        jQuery.ajax({
            type: 'POST',
            url: php_data.site_url + '/wp-admin/admin-ajax.php',
            data: 'action=wpc_files_shortcode_pagination&shortcode_type=' + shortcode_type + '&shortcode_data=' + JSON.stringify( php_data.data ) + '&category_id=' + category_filter + '&search=' + search + '&current_page=' + page_number + '&show_by=' + php_data.show_by + '&exclude_author=' + exclude_author + '&order_by=' + order_by + '&order=' + order + '&client_id=' + client_id + '&security=' + _wpnonce,
            dataType: "json",
            success: function( data ){
                if( !data.status ) {
                    alert( data.message );
                } else {

                    obj.parents( '.wpc_client_files_table' ).find( 'tbody' ).html( data.html );

                    if( obj.hasClass( 'wpc_last' ) ) {

                        obj.parents( '.wpc_client_files_table' ).find('.wpc_last').hide();
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_next_pages' ).hide();
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_next' ).hide();

                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links' ).removeClass( 'wpc_active_page' );
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_next_pages' ).prev().addClass( 'wpc_active_page' ).show();

                        if( page_number*1 > 3 ) {
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_previous_pages' ).show();
                        }
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_previous' ).show();
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_first' ).show();

                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links' ).each( function() {
                            if( jQuery(this).html()*1 > ( Math.floor( ( page_number*1 - 1 ) / 3 ) )*3 && jQuery(this).html()*1 < ( Math.floor( ( page_number*1 - 1 ) / 3 ) + 1 )*3 + 1 ) {
                                jQuery(this).show();
                            } else if( jQuery.isNumeric( jQuery(this).html() ) ) {
                                jQuery(this).hide();
                            }
                        });

                    } else if( obj.hasClass( 'wpc_first' ) ) {

                        obj.parents( '.wpc_client_files_table' ).find('.wpc_first').hide();
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_previous_pages' ).hide();
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_previous' ).hide();

                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links' ).removeClass( 'wpc_active_page' );
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_previous_pages' ).next().addClass( 'wpc_active_page' ).show();

                        if( page_number*1 < ( ( Math.ceil( php_data.count_pages/3 ) - 1)*3 + 1 ) ) {
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_next_pages' ).show();
                        }
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_next' ).show();
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_last' ).show();

                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links' ).each( function() {
                            if( jQuery(this).html()*1 > ( Math.floor( ( page_number*1 - 1 ) / 3 ) )*3 && jQuery(this).html()*1 < ( Math.floor( ( page_number*1 - 1 ) / 3 ) + 1 )*3 + 1 ) {
                                jQuery(this).show();
                            } else if( jQuery.isNumeric( jQuery(this).html() ) ) {
                                jQuery(this).hide();
                            }
                        });

                    } else if( obj.hasClass( 'wpc_next' ) ) {

                        var before_active = obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_active_page' );
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links' ).removeClass( 'wpc_active_page' );
                        before_active.next().addClass( 'wpc_active_page' ).show();

                        if( page_number*1 > 1 ) {
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_previous' ).show();
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_first' ).show();
                        }

                        if( page_number*1 > 3 ) {
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_previous_pages' ).show();
                        }

                        if( page_number*1 == php_data.count_pages*1 ) {
                            obj.parents( '.wpc_client_files_table' ).find( '.wpc_next' ).hide();
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_next_pages' ).hide();
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_last' ).hide();
                        }

                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links' ).each( function() {
                            if( jQuery(this).html()*1 > ( Math.floor( ( page_number*1 - 1 ) / 3 ) )*3 && jQuery(this).html()*1 < ( Math.floor( ( page_number*1 - 1 ) / 3 ) + 1 )*3 + 1 ) {
                                jQuery(this).show();
                            } else if( jQuery.isNumeric( jQuery(this).html() ) ) {
                                jQuery(this).hide();
                            }
                        });

                        if( ( Math.floor( ( page_number*1 - 1 ) / 3 ) + 1 )*3 + 1 > php_data.count_pages ) {
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_next_pages' ).hide();
                        }

                    } else if( obj.hasClass( 'wpc_previous' ) ) {

                        var before_active = obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_active_page' );
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links' ).removeClass( 'wpc_active_page' );
                        before_active.prev().addClass( 'wpc_active_page' ).show();

                        if( page_number*1 < php_data.count_pages*1 ) {
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_next' ).show();
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_last' ).show();
                        }

                        if( page_number*1 < ( ( Math.ceil( php_data.count_pages/3 ) - 1)*3 + 1 ) ) {
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_next_pages' ).show();
                        }

                        if( page_number*1 == 1 ) {
                            obj.parents( '.wpc_client_files_table' ).find( '.wpc_previous' ).hide();
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_previous_pages' ).hide();
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_first' ).hide();
                        }

                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links' ).each( function() {
                            if( jQuery(this).html()*1 > ( Math.floor( ( page_number*1 - 1 ) / 3 ) )*3 && jQuery(this).html()*1 < ( Math.floor( ( page_number*1 - 1 ) / 3 ) + 1 )*3 + 1 ) {
                                jQuery(this).show();
                            } else if( jQuery.isNumeric( jQuery(this).html() ) ) {
                                jQuery(this).hide();
                            }
                        });

                        if( Math.floor( ( page_number*1 - 1 ) / 3 ) == 0 ) {
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_previous_pages' ).hide();
                        }

                    } else if( obj.hasClass( 'wpc_next_pages' ) )  {

                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links' ).removeClass( 'wpc_active_page' );

                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_previous_pages' ).show();
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_previous' ).show();
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_first' ).show();

                        if( ( Math.floor( ( page_number*1 - 1 ) / 3 ) + 1 )*3 + 1 > php_data.count_pages ) {
                            obj.parents( '.wpc_client_files_table' ).find( '.wpc_next_pages' ).hide();
                        }

                        if( page_number*1 == php_data.count_pages ) {
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_next' ).hide();
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_last' ).hide();
                        }

                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links' ).each( function() {
                            if( jQuery(this).html()*1 > ( Math.floor( ( page_number*1 - 1 ) / 3 ) )*3 && jQuery(this).html()*1 < ( Math.floor( ( page_number*1 - 1 ) / 3 ) + 1 )*3 + 1 ) {
                                jQuery(this).show();
                            } else if( jQuery.isNumeric( jQuery(this).html() ) ) {
                                jQuery(this).hide();
                            }

                            if( jQuery(this).html()*1 == page_number*1 ) {
                                jQuery(this).addClass( 'wpc_active_page' );
                            }
                        });

                    } else if( obj.hasClass( 'wpc_previous_pages' ) ) {
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links' ).removeClass( 'wpc_active_page' );

                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_next_pages' ).show();
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_next' ).show();
                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_last' ).show();

                        if( Math.floor( ( page_number*1 - 1 ) / 3 ) == 0 ) {
                            obj.parents( '.wpc_client_files_table' ).find('.wpc_previous_pages').hide();
                        }

                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links' ).each( function() {
                            if( jQuery(this).html()*1 > ( Math.floor( ( page_number*1 - 1 ) / 3 ) )*3 && jQuery(this).html()*1 < ( Math.floor( ( page_number*1 - 1 ) / 3 ) + 1 )*3 + 1 ) {
                                jQuery(this).show();
                            } else if( jQuery.isNumeric( jQuery(this).html() ) ) {
                                jQuery(this).hide();
                            }

                            if( jQuery(this).html()*1 == page_number*1 ) {
                                jQuery(this).addClass( 'wpc_active_page' );
                            }
                        });

                    } else {

                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links' ).removeClass( 'wpc_active_page' );

                        obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links' ).each( function() {
                            if( obj.html() == jQuery(this).html() ) {
                                jQuery(this).addClass( 'wpc_active_page' );
                            }
                        });

                        if( page_number*1 < php_data.count_pages*1 ) {
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_next' ).show();
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_last' ).show();
                        } else {
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_next' ).hide();
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_last' ).hide();
                        }

                        if( page_number*1 > 1 ) {
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_previous' ).show();
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_first' ).show();
                        } else {
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_previous' ).hide();
                            obj.parents( '.wpc_client_files_table' ).find( 'a.wpc_pagination_links.wpc_first' ).hide();
                        }
                    }


                    jQuery( '.wpc_img_file_icon' ).tooltip({
                        items: "[wpc_images]",
                        content: function() {
                            var element = jQuery( this );
                            if ( element.is( "[wpc_images]" ) ) {
                                var text = element.attr( 'wpc_images' );
                                return "<img alt='" + text +
                                "' src='" +
                                text + "'>";
                            }
                        }
                    });
                }
            }
        });

    });


    jQuery('.wpc_client_files .file-description-wrapper').hover(function(){
        if (!jQuery(this).hasClass('animated')) {
            jQuery(this).children('.file-description').dequeue().stop().slideDown();
        }
    }, function() {
        jQuery(this).addClass('animated').children('.file-description').fadeOut('normal', function() {
            jQuery(this).parent().removeClass('animated').children('.file-description').dequeue();
        });
    });

});


function display_table_data( php_data, file ) {
    var html = '';

    html += '<tr>';

    if( php_data.shortcode_atts.show_thumbnails == 'yes' ) {
        html += '<td class="wpc_file_icon">' + file.icon + '</td>';
    }

    html += '<td class="name"><span class="wpc_filedata wpc_file_name_value">' + file.title + '</span></td>';

    if( php_data.shortcode_atts.show_size == 'yes' ) {
        html += '<td class="size" data-size="' + file.size + '"><span class="wpc_filedata wpc_file_size_value">' + file.size + '</span></td>';
    }

    if( php_data.show_tags == 'yes' ) {
        html += '<td class="tags"><span class="wpc_filedata wpc_file_tags_value">' + file.tags + '</span></td>';
    }

    if( php_data.shortcode_atts.show_date == 'yes' ) {
        html += '<td class="time" data-timestamp="' + file.timestamp + '"><span class="wpc_filedata wpc_file_added_value">' + file.date + ' ' + file.time + '</span></td>';
    }

    if( php_data.shortcode_atts.show_last_download_date == 'yes' ) {
        html += '<td class="download_time" data-timestamp="';
        if( file.hasOwnProperty('last_download') ) {
            html += file.last_download.timestamp
        }
        html += '"><span class="wpc_filedata wpc_file_downloaded_value">';
        if( file.hasOwnProperty('last_download') ) {
            html += file.last_download.date + ' ' + file.last_download.time
        }
        html += '</span></td>';
    }

    if( php_data.shortcode_atts.show_file_cats == 'yes' ) {
        html += '<td class="cat"><span class="wpc_filedata wpc_file_category_value">' + file.category_name + '</span></td>';
    }

    if( php_data.shortcode_atts.show_actions == 'yes' ) {
        html += '<td class="actions"><span class="wpc_file_actions">';
        if( file.new_page == true ) {
            html += '<a href="' + file.view_url + '" title="View" target="_blank" class="wp_file_view_link"></a><span style="float:left;">&nbsp;|&nbsp;</span>';
        }

        html += '<a href="' + file.url + '" title="Download" ';
        if( file.new_page == true ) {
            html += 'target="_blank" ';
        }
        html += 'class="wp_file_download_link"></a>';

        if( php_data.client_can_delete == true && file.delete_url != '' ) {
            html += '<span style="float:left;">&nbsp;|&nbsp;</span><a onclick="return confirm(\'Are you sure to delete this file? \');" href="' + file.delete_url + '" title="Delete" class="wp_file_delete_link"></a>';
        }
        html += '</span></td>';
    }

    html += '</tr>';

    return html;
}
